﻿'Program:       Homework 5
'Programmer:    DePinto
'Date:          Fall 2014
'Page:          Default
'Description:   A Web site to calculate the extended price for books sold, 
'               a discount, and the the discounted amount. Calculates and displays
'               the total discounts.
'               Uses validator controls for input validation.

Partial Class _Default
    Inherits System.Web.UI.Page
    Private DiscountTotalDecimal As Decimal

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' Check for hidden value.

        With DiscountHiddenField
            If IsPostBack And .Value <> "" Then
                DiscountTotalDecimal = Decimal.Parse(.Value)
            End If
        End With
    End Sub

    Protected Sub SubmitButton_Click(ByVal sender As Object, ByVal e As EventArgs) Handles SubmitButton.Click
        ' Calculate values for sale.
        Dim TheBookSale As BookSale

        ErrorMessageLabel.Text = String.Empty
        Try
            'Convert input values to numeric variables.
            TheBookSale = New BookSale(TitleTextBox.Text,
                                       Integer.Parse(QuantityTextBox.Text),
                                       Decimal.Parse(PriceTextBox.Text))

            'Add to the discount total.
            DiscountTotalDecimal += TheBookSale.Discount

            'Save the discount total in a label.
            DiscountHiddenField.Value = DiscountTotalDecimal.ToString()

            'Format and display answers.
            With TheBookSale
                ExtendedPriceTextBox.Text = .ExtendedPrice.ToString("C")
                DiscountTextBox.Text = .Discount.ToString("c")
                DiscountPriceTextBox.Text = .DiscountedPrice.ToString("C")
            End With

        Catch ex As Exception
            ErrorMessageLabel.Text = "Unable to calculate. Check for numeric values."
        End Try
    End Sub

    Private Sub ClearButton_Click(ByVal sender As Object,
  ByVal e As System.EventArgs) Handles ClearButton.Click
        ' Clear previous amounts from the page.

        QuantityTextBox.Text = ""
        TitleTextBox.Text = ""
        PriceTextBox.Text = ""
        ExtendedPriceTextBox.Text = ""
        DiscountTextBox.Text = ""
        DiscountPriceTextBox.Text = ""
        DiscountTotalLabel.Text = ""
        ErrorMessageLabel.Text = ""
    End Sub

    Private Sub SummaryButton_Click(ByVal sender As Object,
  ByVal e As System.EventArgs) Handles SummaryButton.Click
        ' Display the total discount.

        'DiscountTotalLabel.Text = "Total Discounts: $" & DiscountHiddenField.Value
        DiscountTotalLabel.Text = "Total Discounts: " & DiscountTotalDecimal.ToString("C")

    End Sub
End Class
